using System;
using System.Collections.Generic;
using System.Text;
using System.Xml.Serialization;

namespace XmlProviders.Data
{
    /// <summary>
    /// 
    /// </summary>
    [Serializable()]
    public class ProfileProperty
    {
        private string _key;
        private object _value;

        /// <summary>
        /// Initializes a new instance of the <see cref="ProfileProperty"/> class.
        /// </summary>
        public ProfileProperty() { }

        /// <summary>
        /// Initializes a new instance of the <see cref="ProfileProperty"/> class.
        /// </summary>
        /// <param name="key">The key.</param>
        public ProfileProperty(string key)
        {
            _key = key;
        }

        /// <summary>
        /// Gets or sets the key.
        /// </summary>
        /// <value>The key.</value>
        [XmlAttribute("name")]
        public string Key
        {
            get { return _key; }
            set { _key = value; }
        }

        /// <summary>
        /// Gets or sets the value.
        /// </summary>
        /// <value>The value.</value>
        [XmlElement(DataType = "base64Binary", Type = typeof(byte[]), ElementName = "binaryValue")]
        [XmlElement(typeof(string), ElementName = "value")]
        public object Value
        {
            get { return _value; }
            set { _value = value; }
        }
    }
}
