using System;
using System.Collections.Generic;
using System.Text;
using System.Xml.Serialization;

namespace XmlProviders.Data
{
    /// <summary>
    /// 
    /// </summary>
    [Serializable()]
    public class Workspace
    {
        private string _username;
        private string _path;
        private byte[] _personalization;

        /// <summary>
        /// Gets or sets the name of the user.
        /// </summary>
        /// <value>The name of the user.</value>
        [XmlAttribute("username")]
        public string UserName
        {
            get { return _username; }
            set { _username = value; }
        }

        /// <summary>
        /// Gets or sets the path.
        /// </summary>
        /// <value>The path.</value>
        [XmlAttribute("path")]
        public string Path
        {
            get { return _path; }
            set { _path = value; }
        }

        /// <summary>
        /// Gets or sets the personalization BLOB.
        /// </summary>
        /// <value>The personalization BLOB.</value>
        [XmlText(typeof(byte[]))]
        public byte[] PersonalizationBlob
        {
            get { return _personalization; }
            set { _personalization = value; }
        }
    }
}
